"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitLandingHeader = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable @typescript-eslint/no-namespace */
/* eslint-disable @typescript-eslint/ban-types */
var TopBar_1 = require("./components/TopBar");
var Typography_1 = require("onyxia-ui/Typography");
var Image_1 = require("./components/Image");
var tss_react_1 = require("tss-react");
var react_1 = require("react");
var react_markdown_1 = __importDefault(require("react-markdown"));
var DownArrow_1 = require("./components/DownArrow");
var Link_1 = __importDefault(require("@material-ui/core/Link"));
var theme_1 = require("./theme");
var powerhooks_1 = require("powerhooks");
var getUseClassNames = function () {
    var createUseClassNames = theme_1.getThemeApi().createUseClassNames;
    var useClassNames = createUseClassNames()(function (theme, _a) {
        var _b, _c;
        var background = _a.background;
        return ({
            "root": {
                "position": "relative",
                "width": "100%",
                "display": "flex",
                "flexDirection": "column",
                "alignItems": "center",
                "& p": {
                    "margin": 0,
                },
            },
            "presentation": {
                "display": "flex",
                "width": "100%",
                "boxSizing": "border-box",
                "justifyContent": "center",
                "marginTop": theme.spacing(5),
            },
            "presentationText": (_b = {
                    "position": "relative",
                    "left": 100,
                    "textAlign": "left",
                    "width": 994,
                    "zIndex": 1,
                    "& h2": {
                        "fontSize": "86px",
                        "marginBottom": theme.spacing(4),
                        "width": 1000,
                    },
                    "& h3": {
                        "width": 650,
                        "fontWeight": 400,
                        "lineHeight": "40px",
                    }
                },
                _b[theme.breakpoints.down(1440)] = {
                    "width": 650,
                    "left": 100,
                    "& h2": {
                        "fontSize": "52px",
                        "width": "unset",
                    },
                    "& h3": {
                        "lineHeight": "20px",
                        "fontSize": "18px",
                        "width": 450,
                    },
                },
                _b),
            "image": (_c = {
                    "position": "relative",
                    "right": 100,
                    "width": 900
                },
                _c[theme.breakpoints.down(1440)] = {
                    "width": 755,
                    "right": theme.spacing(4.5),
                },
                _c),
            "backgroundDiv": {
                "background": (function () {
                    if (background === undefined) {
                        return undefined;
                    }
                    if (background.type === "color") {
                        return theme.isDarkModeEnabled
                            ? background.backgroundColor
                            : background.backgroundColor;
                    }
                    return "\n                    url(\"" + (theme.isDarkModeEnabled ? background.imageUrl : background.imageUrl) + "\")\n                ";
                })(),
                "backgroundRepeat": "no-repeat",
                "backgroundSize": "cover",
                "backgroundPosition": "center",
                "width": "100%",
                "height": "100%",
                "position": "absolute",
                "top": 0,
                "left": 0,
                "zIndex": -1,
                "filter": theme.isDarkModeEnabled ? "brightness(0.8)" : undefined,
            },
            "button": {
                "color": theme.isDarkModeEnabled ? "white" : "black",
                "margin": 15,
            },
            "buttonWrapper": {
                "marginTop": 30,
                "marginBottom": 30,
                "maxWidth": 650,
            },
            "linkToMainSection": {
                "display": "flex",
                "flexDirection": "column",
                "alignItems": "center",
                "marginTop": theme.spacing(10),
                "& h3": {
                    "fontWeight": 400,
                    "marginBottom": 21,
                },
            },
        });
    }).useClassNames;
    return { useClassNames: useClassNames };
};
exports.GitLandingHeader = react_1.memo(function (props) {
    var image = props.image, titleMd = props.titleMd, subTitleMd = props.subTitleMd, background = props.background, topBarProps = props.topBarProps, className = props.className, linkToMainSection = props.linkToMainSection;
    var useClassNames = powerhooks_1.useGuaranteedMemo(function () { return getUseClassNames(); }, []).useClassNames;
    var classNames = useClassNames({ background: background }).classNames;
    return (jsx_runtime_1.jsxs("header", __assign({ className: tss_react_1.cx(classNames.root, className) }, { children: [jsx_runtime_1.jsx("div", { className: classNames.backgroundDiv }, void 0),
            topBarProps !== undefined && jsx_runtime_1.jsx(TopBar_1.TopBar, __assign({}, topBarProps), void 0),
            jsx_runtime_1.jsxs("div", __assign({ className: classNames.presentation }, { children: [jsx_runtime_1.jsxs("div", __assign({ className: classNames.presentationText }, { children: [titleMd && (jsx_runtime_1.jsx(Typography_1.Typography, __assign({ variant: "h2" }, { children: jsx_runtime_1.jsx(react_markdown_1.default, { children: titleMd }, void 0) }), void 0)),
                            subTitleMd && (jsx_runtime_1.jsx(Typography_1.Typography, __assign({ variant: "h3" }, { children: jsx_runtime_1.jsx(react_markdown_1.default, { children: subTitleMd }, void 0) }), void 0))] }), void 0),
                    image !== undefined && (jsx_runtime_1.jsx(Image_1.Image, { className: tss_react_1.cx(classNames.image, image.className), url: image.url, alt: image.alt }, void 0))] }), void 0),
            linkToMainSection && (jsx_runtime_1.jsxs("div", __assign({ className: classNames.linkToMainSection }, { children: [jsx_runtime_1.jsx(Typography_1.Typography, __assign({ variant: "h3" }, { children: jsx_runtime_1.jsx(react_markdown_1.default, { children: linkToMainSection.title }, void 0) }), void 0),
                    jsx_runtime_1.jsx(Link_1.default, __assign({ href: "#main-section" }, { children: jsx_runtime_1.jsx(DownArrow_1.DownArrow, {}, void 0) }), void 0)] }), void 0))] }), void 0));
});
//# sourceMappingURL=GitLandingHeader.js.map